Unit HtmlTitle;

{
  HtmlTitle unit contains encapsulated HTML file-handling
  routines and engines written for "HTML Indexer" by
  Gregory L Fox August 1999.

1) ExtractHTMLTitle takes two parameters - filename, which is
    just a string of a filename, eg. 'c:\temp\temp.html'
    plus a second parameter, 'interactive', which controls
    parts of the code which prompt the end-user for a title
    where no title tag is found.
    A setting of TRUE means you want prompts, and FALSE means
    automatically use 'Untitled'.
    Please note that a result beginning "_-_" means abort interactivity
      option. You must manually reset your interactivity option if
      'abort' is to be a valid choice.

 }

interface
Uses  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FMXUtils;


function ExtractHTMLTitle(filename:string;interactive:boolean):string;

implementation

function ExtractHTMLTitle(filename:string;interactive:boolean):string;
const header:integer=8; //number of lines to concatenate to form the search string
      autolength:integer=25; //number of characters in an unterminated <title> tag's assumed contents
var t,g,x,n:integer;
a,b:string;
answer:TModalResult;
webpage:tstrings;
begin
if not fileexists(filename) then begin result:='File Not Found';exit;end;
webpage:=tstringlist.create;
webpage.loadfromfile(filename);
g:=webpage.count-2; if g>header then g:=header;
a:='';
for t:=0 to g do begin
a:=a+webpage[t];
end;
b:=lowercase(a);
x:=pos('<title>',b);
if x<1 then begin
             result:='Untitled';
             if interactive then
              begin
               answer:=MessageDlg((filename+' - Launch page for evaluation?'),
               mtConfirmation, [mbYes,mbNo,mbIgnore,mbAbort], 0);
               if answer=mrYes then ExecuteFile( filename , '' , '' , SW_SHOW );
               if answer=mrAbort then begin result:='_-_'+result;webpage.free;exit;end;
               if answer=mrIgnore then begin webpage.free;exit;end;
               result:=inputbox('Title prompt','Please enter the title of page:'+filename,result);
               webpage.insert(0,'<html><title>'+result+'</title>');
               webpage.savetofile(filename);
              end;
             webpage.free;
             exit;
            end;
n:=pos('</title>',b); if n<1 then n:=x+autolength;
n:=n-(x+7);
result:=copy(a,x+7,n);
b:=lowercase(result);
if comparestr(trim(b)+'x','x')=0 then begin b:=' untitled ';result:='Untitled';end;
if ((interactive) and (pos('untitled',b)>1)) then
 begin
  answer:=MessageDlg((filename+' - Launch page for evaluation?'),
  mtConfirmation, [mbYes,mbNo,mbIgnore,mbAbort], 0);
  if answer=mrYes then ExecuteFile( filename , '' , '' , SW_SHOW );
  if answer=mrAbort then begin result:='_-_'+result;webpage.free;exit;end;
  if answer=mrIgnore then begin webpage.free;exit;end;
  result:=inputbox('Title prompt','Please enter the title of page:'+filename,result);
  if (comparestr('Untitled',result)<>0) then begin
  webpage.insert(0,'<html><title>'+result+'</title>');
  webpage.savetofile(filename);              end;//save title to actual file
 end;
webpage.free;
exit;
end;

end.